<?php
namespace Pantheon\Checks;

use Pantheon\Utils;
use Pantheon\Checkimplementation;
use Pantheon\Messenger;

class Exploited extends Checkimplementation {

  public function init() {
    $this->action = 'No exploits found.';
    $this->description = 'Looking for exploited files.';
    $this->score = 2;
    $this->result = '';
    $this->label = 'Probable exploits';
    $this->alerts = array();
    self::$instance = $this;
    return $this;
  }

  public function run($file) {
    $regex = '.*eval\(.*base64_decode\(.*';
    preg_match('#'.$regex.'#s',$file->getContents(), $matches, PREG_OFFSET_CAPTURE );
    if ( $matches ) {
      $note = '';
      if (count($matches) > 1) {
        array_shift($matches);
      }
      foreach ($matches as $match) {
        $note .= sprintf(" [ Line %d, Match: '%s']", $match[1] + 1, substr($match[0],0,50) );
      }
      $this->alerts[] = $file->getRelativePathname().$note;
    }
    return $this;
  }

  public function message(Messenger $messenger) {
      if (!empty($this->alerts)) {
        if ('json' != Utils::get('format')) {
          $details = sprintf( "Found %s files that contain likely exploits \n\t-> %s",
            count($this->alerts),
            join("\n\t-> ", $this->alerts)
          );
          $this->result .= $details;
        } else {
          $this->result = $this->alerts;
        }
        $this->score = -1;
        $this->action = "You should deactivate this plugin unless you can verify this is the intended use.";
    }
    $messenger->addMessage(get_object_vars($this));
  }
}
